#![allow(dead_code)]

mod tag;
mod util;
mod runtime;
mod interface; pub use interface::*;
mod encoding; pub use encoding::*;

/* pub fn test() {
    use std::fs::File;
    use std::io::prelude::*;

    const MAGAZINE :usize     = 0x100;
    const MAGAZINE_ROW :usize = 0x101;

    // define schema "Magazine Row"
    Schema::with(vec![
        ("Content", natural()),
        ("Quantity", natural()),
    ]).bind(MAGAZINE_ROW);

    // define schema "Magazine"
    let magazine = Schema::with(vec![
        ("Capacity", natural()),
        ("Quantity", natural()),
        ("Content", list(record(MAGAZINE_ROW))),
    ]);
    magazine.bind(MAGAZINE);

    // create record "Magazine"
    let _data = Record::with(MAGAZINE, vec![
        ("Capacity", *Natural::with(30)),
        ("Quantity", *Natural::with(25)),
        ("Content", *List::with(record(MAGAZINE_ROW), vec![
            *Record::with(MAGAZINE_ROW, vec![
                ("Content", *Natural::with(15)),
                ("Quantity", *Natural::with(5)),
            ]).unwrap(),
            *Record::with(MAGAZINE_ROW, vec![
                ("Content", *Natural::with(16)),
                ("Quantity", *Natural::with(20)),
            ]).unwrap(),
        ])),
    ]).unwrap();

    // encode record
    let out = encode(*magazine);

    // write encoding to file
    let mut file = File::create("target/dat.szn").unwrap();
    file.write_all(&out).ok();

    // print hex series of encoding
    print!("[{}]: ", out.len());
    for byte in &out {
        print!("{:02x} ", *byte);
    } println!("");

    match decode(&out, &mut 0) {
        Ok(t) => match t {
            Type::Schema(data) => {
                println!("len: {}", data.length());
                for i in 0..data.length() {
                    println!("'{}': {} ({:02x})", data.keyof(i).unwrap(), data.get(i).unwrap(), kind(data.get(i).unwrap()));
                }
            }
            _ => { println!("not expected"); }
        }
        Err(_) => { println!("failed"); }
    }
} */

#[cfg(test)]
mod tests;
