use crate::*;

#[test]
fn block_initialize()
{
    let value = Block::new(8);
    assert_eq!(8, value.size(), "Block::new(8) has length of 8.");
    assert_eq!(vec![0;8], value.get(), "Block::new(8) has value of 0.");
}

#[test]
fn block_set_get()
{
    let mut value = Block::new(4);
    value.set(vec![1, 2, 3, 4]);
    assert_eq!(vec![1, 2, 3, 4], value.get(), "Block::set([1,2,3,4]) has value of [1,2,3,4].");
}
