use crate::*;

#[test]
fn boolean_initialize()
{
    let value = Boolean::new();
    assert_eq!(false, value.get(), "Boolean::new() produces value of false.");
}

#[test]
fn boolean_with()
{
    assert_eq!(false, Boolean::with(false).get(), "Boolean::with(false) produces value of false.");
    assert_eq!(true, Boolean::with(true).get(), "Boolean::with(true) produces value of true.");
}

#[test]
fn boolean_set_get()
{
    let mut value = Boolean::new();
    value.set(true);
    assert_eq!(true, value.get(), "Boolean.set(true) produces value of true.");
    value.set(false);
    assert_eq!(false, value.get(), "Boolean.set(false) produces value of false.");
}
